/*
 * 
 *  dynamic linker command file
 *  generated: Tue Feb  5 12:16:55 2002

 *  kernel   : legOS
 *  app start: 0xa482
 * 
 *  legOS - the independent LEGO Mindstorms OS
 *  (c) 1999 by Markus L. Noga <markus@noga.de>    
 * 
 */

OUTPUT_FORMAT("symbolsrec")
OUTPUT_ARCH(h8300)
ENTRY("_main")

MEMORY {
  rom   : o = 0x0000, l = 0x8000
  kern  : o = 0x8000, l = 0x2482
  ram   : o = 0xa482, l = 0x5a7a
  stack : o = 0xfefc, l = 0x0004
  eight : o = 0xff00, l = 0x0100
}

SECTIONS {

  .rom : {
    /* used rom functions */
    
    _rom_reset_vector = 0x0000;
        
    _reset        = 0x03ae ;
    lcd_show      = 0x1b62 ;
    lcd_hide      = 0x1e4a ;
    lcd_number    = 0x1ff2 ;
    lcd_clear     = 0x27ac ;
    power_init    = 0x2964 ;
    sound_system  = 0x299a ;
    power_off     = 0x2a62 ;
    sound_playing = 0x3ccc ;

    _rom_dummy_handler   = 0x046a ;
    _rom_ocia_handler    = 0x04cc ;
    _rom_ocia_return     = 0x04d4 ;
    
  } > rom

  .kernel :	{
    /* kernel symbols (relative to 0x8000) */
    _kmain = 0x0000 ;
    _mm_try_join = 0x00d6 ;
    _mm_update_first_free = 0x0106 ;
    _mm_init = 0x012c ;
    _malloc = 0x01b2 ;
    _free = 0x0258 ;
    _calloc = 0x0282 ;
    _mm_reaper = 0x02aa ;
    _systime_handler = 0x0306 ;
    _systime_tm_return = 0x03a2 ;
    _systime_init = 0x03b2 ;
    _systime_shutdown = 0x03fc ;
    _systime_set_switcher = 0x0404 ;
    _systime_set_timeslice = 0x040a ;
    _tm_switcher = 0x0420 ;
    _tm_scheduler = 0x043c ;
    _yield = 0x0604 ;
    _tm_init = 0x0622 ;
    _tm_start = 0x0664 ;
    _execi = 0x0674 ;
    _exit = 0x0814 ;
    _wait_event = 0x0836 ;
    _msleep = 0x089e ;
    _sleep = 0x08c0 ;
    _kill = 0x08de ;
    _killall = 0x091a ;
    _sem_event_wait = 0x0982 ;
    _sem_wait = 0x099a ;
    _sem_trywait = 0x09ba ;
    _sem_post = 0x09d2 ;
    _delay = 0x09e2 ;
    _cputc_native = 0x0a02 ;
    _cputc_native_0 = 0x0a30 ;
    _cputc_native_1 = 0x0a64 ;
    _cputc_native_2 = 0x0a9a ;
    _cputc_native_3 = 0x0ad4 ;
    _cputc_native_4 = 0x0b10 ;
    _cputc_native_5 = 0x0b4c ;
    _cputw = 0x0b58 ;
    _cputs = 0x0b9c ;
    _cls = 0x0be4 ;
    _lcd_number = 0x0bec ;
    _lcd_refresh_next_byte = 0x0c90 ;
    _lcd_refresh_next_byte_core = 0x0ca4 ;
    _lcd_refresh = 0x0cf4 ;
    _lcd_power_on = 0x0d24 ;
    _lcd_power_off = 0x0d36 ;
    _lcd_init = 0x0d52 ;
    _rx_handler = 0x0d9c ;
    _rx_core = 0x0db0 ;
    _rxerror_handler = 0x0e1c ;
    _rxerror_core = 0x0e30 ;
    _txend_handler = 0x0e76 ;
    _txend_core = 0x0e8a ;
    _tx_handler = 0x0e98 ;
    _tx_core = 0x0eac ;
    _lnp_logical_shutdown = 0x0ed4 ;
    _lnp_logical_init = 0x0ef4 ;
    _lnp_logical_write = 0x0fa6 ;
    _lnp_integrity_write = 0x1056 ;
    _lnp_addressing_write = 0x10ae ;
    _lnp_receive_packet = 0x1128 ;
    _lnp_integrity_byte = 0x11b4 ;
    _lnp_integrity_reset = 0x1276 ;
    _lnp_integrity_reset_core = 0x128a ;
    _lnp_timeout_reset = 0x12b8 ;
    _lnp_timeout_reset_core = 0x12cc ;
    _lnp_init = 0x12d6 ;
    _lnp_integrity_active = 0x12f0 ;
    _lnp_timeout_set = 0x12fc ;
    _program_valid = 0x1306 ;
    _key_handler = 0x1650 ;
    _program_init = 0x1754 ;
    _program_shutdown = 0x179a ;
    _vis_handler = 0x17a4 ;
    _vis_core = 0x17b8 ;
    _get_battery_mv = 0x1810 ;
    _battery_refresh = 0x183a ;
    _battery_refresh_core = 0x184e ;
    _shutoff_restart = 0x1878 ;
    _shutoff_init = 0x1888 ;
    _autoshutoff_check = 0x1894 ;
    _autoshutoff_check_core = 0x18a8 ;
    _dkey_handler = 0x18d8 ;
    _dkey_pressed = 0x1916 ;
    _dkey_released = 0x1938 ;
    _getchar = 0x1958 ;
    _dm_handler = 0x1982 ;
    _dm_init = 0x19c0 ;
    _dm_shutdown = 0x19c4 ;
    _motor_a_dir = 0x19e8 ;
    _motor_b_dir = 0x1a2a ;
    _motor_c_dir = 0x1a70 ;
    _ds_rotation_set = 0x1ab4 ;
    _ds_rotation_handler = 0x1b08 ;
    _ds_init = 0x1bf8 ;
    _ds_shutdown = 0x1c2e ;
    _dsound_handler = 0x1c46 ;
    _dsound_core = 0x1c5a ;
    _dsound_init = 0x1d54 ;
    _dsound_shutdown = 0x1d6c ;
    _dsound_stop = 0x1d70 ;
    _dsound_finished = 0x1d90 ;
    _memset = 0x1daa ;
    _memcpy = 0x1db8 ;
    ___mulhi3 = 0x1dca ;
    ___mulsi3 = 0x1dda ;
    ___divsi3 = 0x1df6 ;
    _hex_display_codes = 0x1e34 ;
    _ascii_display_codes = 0x1e44 ;
    _min_length = 0x1ed6 ;
    _dm_a_pattern = 0x1ee8 ;
    _dm_b_pattern = 0x1eec ;
    _dm_c_pattern = 0x1ef0 ;
    _firmware_string = 0x1fd2 ;
    _etext = 0x1fd2 ;
    _lcd_refresh_period = 0x1fd6 ;
    _lnp_timeout = 0x1fd8 ;
    _vis_refresh_counter = 0x1fda ;
    _vis_refresh_period = 0x1fdb ;
    _battery_refresh_counter = 0x1fdc ;
    _battery_refresh_period = 0x1fde ;
    _auto_shutoff_counter = 0x1fe0 ;
    _auto_shutoff_period = 0x1fe2 ;
    _auto_shutoff_secs = 0x1fe4 ;
    _auto_shutoff_elapsed = 0x1fe6 ;
    _idle_powerdown = 0x1fe8 ;
    _dsound_system_sounds = 0x1fea ;
    __edata = 0x1fec ;
    _bss_start = 0x1ff0 ;
    _mm_semaphore = 0x23d8 ;
    _mm_first_free = 0x23da ;
    _tm_timeslice = 0x23dc ;
    _tm_current_slice = 0x23dd ;
    _tm_switcher_vector = 0x23de ;
    _sys_time = 0x23e0 ;
    _pd_idle = 0x23f0 ;
    _cpid = 0x23f2 ;
    _nb_tasks = 0x23f4 ;
    _priority_head = 0x23f6 ;
    _pd_single = 0x2400 ;
    _task_sem = 0x2414 ;
    _lcd_byte_counter = 0x2416 ;
    _lcd_refresh_counter = 0x2417 ;
    _tx_state = 0x2418 ;
    _tx_sem = 0x2419 ;
    _lnp_integrity_handler = 0x2420 ;
    _lnp_timeout_counter = 0x2422 ;
    _lnp_addressing_handler = 0x2430 ;
    _lnp_integrity_state = 0x2450 ;
    _packet_len = 0x2452 ;
    _cprog = 0x2454 ;
    _packet_src = 0x2456 ;
    _dkey_timer = 0x2458 ;
    _dkey = 0x2459 ;
    _dkey_multi = 0x245a ;
    _dm_a = 0x245c ;
    _dm_b = 0x2460 ;
    _dm_c = 0x2464 ;
    _ds_rotation = 0x2468 ;
    _ds_channel = 0x2469 ;
    _ds_rotations = 0x246c ;
    _ds_activation = 0x2472 ;
    _dsound_next_note = 0x2474 ;
    _dsound_internote_ms = 0x2476 ;
    _dsound_16th_ms = 0x2478 ;
    _dsound_next_time = 0x247c ;
    _end = 0x2480 ;
    _mm_start = 0x2480 ;
    /* end of kernel symbols */
  }  > kern
      
  .text BLOCK(2) :	{
    ___text = . ;
    *(.text) 	      /* must start with text for clean entry */			
    *(.rodata)
    *(.strings)
    *(.vectors)       /* vectors region (dummy) */
    *(.persist)

    ___text_end = . ;
  }  > ram

  .tors BLOCK(2) : {
    ___ctors = . ;
    *(.ctors)
    ___ctors_end = . ;
    ___dtors = . ;
    *(.dtors)
    ___dtors_end = . ;
  }  > ram

  .data BLOCK(2) : {
    ___data = . ;
    *(.data)
    *(.tiny)
    ___data_end = . ;
  }  > ram

  .bss BLOCK(2) : {
    ___bss = . ;
    *(.bss)
    *(COMMON)
    ___bss_end = ALIGN(2) ;
  }  >ram

  .stack : {
    _stack = . ; 
    *(.stack)
  }  > topram

  .eight 0xff00: {
    *(.eight)

    /* on-chip module registers (relative to 0xff00) */

    _T_IER = 0x90 ;
    _T_CSR = 0x91 ;
    _T_CNT = 0x92 ;
    _T_OCRA = 0x94 ;
    _T_OCRB = 0x94 ;
    _T_CR = 0x96 ;
    _T_OCR = 0x97 ;
    _T_ICRA = 0x98 ;
    _T_ICRB = 0x9a ;
    _T_ICRC = 0x9c ;
    _T_ICRD = 0x9e ;
    _PORT1_PCR = 0xac ;
    _PORT2_PCR = 0xad ;
    _PORT3_PCR = 0xae ;
    _PORT1_DDR = 0xb0 ;
    _PORT2_DDR = 0xb1 ;
    _PORT1 = 0xb2 ;
    _PORT2 = 0xb3 ;
    _PORT3_DDR = 0xb4 ;
    _PORT4_DDR = 0xb5 ;
    _PORT3 = 0xb6 ;
    _PORT4 = 0xb7 ;
    _PORT5_DDR = 0xb8 ;
    _PORT6_DDR = 0xb9 ;
    _PORT5 = 0xba ;
    _PORT6 = 0xbb ;
    _PORT7 = 0xbe ;
    _STCR = 0xc3 ;
    _SYSCR = 0xc4 ;
    _T0_CR = 0xc8 ;
    _T0_CSR = 0xc9 ;
    _T0_CORA = 0xca ;
    _T0_CORB = 0xcb ;
    _T0_CNT = 0xcc ;
    _T1_CR = 0xd0 ;
    _T1_CSR = 0xd1 ;
    _T1_CORA = 0xd2 ;
    _T1_CORB = 0xd3 ;
    _T1_CNT = 0xd4 ;
    _S_MR = 0xd8 ;
    _S_BRR = 0xd9 ;
    _S_CR = 0xda ;
    _S_TDR = 0xdb ;
    _S_SR = 0xdc ;
    _S_RDR = 0xdd ;
    _AD_A = 0xe0 ;
    _AD_A_H = 0xe0 ;
    _AD_A_L = 0xe1 ;
    _AD_B = 0xe2 ;
    _AD_B_H = 0xe2 ;
    _AD_B_L = 0xe3 ;
    _AD_C = 0xe4 ;
    _AD_C_H = 0xe4 ;
    _AD_C_L = 0xe5 ;
    _AD_D = 0xe6 ;
    _AD_D_H = 0xe6 ;
    _AD_D_L = 0xe7 ;
    _AD_CSR = 0xe8 ;
    _AD_CR = 0xe9 ;
    
    /* end of on-chip module registers */
    
  }  > eight

  .stab 0 (NOLOAD) : {
    [ .stab ]
  }

  .stabstr 0 (NOLOAD) : {
    [ .stabstr ]
  }

} /* SECTIONS */
